SystemOrganization addCategory: #'Ice-Monticello'!

MCWriter subclass: #MCIceWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Monticello'!

!MCIceWriter class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 22:27'!
fileOut: aVersion on: aRepository
	(self on: aRepository)
		writeVersion: aVersion! !

!MCIceWriter methodsFor: 'private' stamp: 'EstebanLorenzano 2/15/2012 10:36'!
metadataReference 
	^(self reference / MCIceRepository metadataFileName) 
		ensureDirectory;
		yourself  ! !

!MCIceWriter methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 22:29'!
reference
	^stream! !

!MCIceWriter methodsFor: 'private' stamp: 'EstebanLorenzano 2/15/2012 10:36'!
test 
	^(self reference / MCIceRepository metadataFileName) 
		ensureDirectory;
		yourself  ! !

!MCIceWriter methodsFor: 'private' stamp: 'EstebanLorenzano 2/15/2012 10:37'!
toStringVersionInfo: info 
	^String streamContents: [ :stringStream |
		stringStream
			nextPutAll: 'MCVersionInfo'; cr;
			tab; nextPutAll: ('parseName: ''{1}''' format: { info name }); cr;
			tab; nextPutAll: ('id: ''{1}''' format: { info id asString }); cr;
			tab; nextPutAll: ('message: ''{1}''' format: { info message }); cr;
			tab; nextPutAll: ('date: ''{1}''' format: { info date}); cr;
			tab; nextPutAll: ('time: ''{1}''' format: { info time }); cr;
			tab; nextPutAll: ('author: ''{1}''' format: { info author}); cr ]! !

!MCIceWriter methodsFor: 'private' stamp: 'EstebanLorenzano 2/14/2012 23:03'!
toStringVersionInfos: aCollection 
	aCollection isEmptyOrNil ifTrue: [ ^'#()' ].
	
	^String streamContents: [ :stringStream | 
		stringStream nextPut: ${; cr.
		aCollection do: [ :each | stringStream nextPutAll: (self toStringVersionInfo: each) ].
		stringStream nextPut: $}; cr. ]! !

!MCIceWriter methodsFor: 'private' stamp: 'EstebanLorenzano 2/15/2012 11:30'!
writeClassDefinition: classDefinition withMethods: methodDefinitionCollection isExtension: extension
	| directory file definitions |
	
	directory := extension 
		ifTrue: [ (self reference  / MCIceRepository extensionsFileName) ensureDirectory ]
		ifFalse: [ (self reference / classDefinition category) ensureDirectory ].
	
	definitions := (extension 
		ifTrue: [ #() ]
		ifFalse: [ Array with: classDefinition ]),
		(methodDefinitionCollection sort: [ :a :b | a sortKey < b sortKey ])	.
		
	self flag: #todo. "Not using #withExtension: because it is bugged"
	file := directory / (classDefinition className asString, '.', MCIceRepository extension).
	file exists ifTrue: [ file delete ].
	file writeStreamDo: [ :fileStream | 
		| bytes |
		bytes := String new writeStream.
		(MCStWriter on: bytes) writeDefinitions: definitions.
		fileStream nextPutAll: bytes contents ]! !

!MCIceWriter methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/15/2012 11:07'!
writeDefinitions: aVersion
	| classes methods extensionClasses |

	classes := aVersion snapshot definitions select: #isClassDefinition.
	methods := aVersion snapshot definitions select: #isMethodDefinition.		

	"Regular classes/traits"
	classes do: [ :eachClass | 
		self 
			writeClassDefinition: eachClass 
			withMethods: (methods select: [ :eachMethod | eachMethod className = eachClass className ])
			isExtension: false ].

	"Extension methods"
	extensionClasses := ((methods 
		select: [ :each | each category beginsWith: '*' ])
		collect: [ :each | each className ] as: Set)
		collect: [ :each | (Smalltalk globals at: each asSymbol) asClassDefinition ] as: Array.
	extensionClasses do: [ :eachClass | 
		self 
			writeClassDefinition: eachClass
			withMethods: (methods select: [ :eachMethod | eachMethod className = eachClass className ])
			isExtension: true ].
! !

!MCIceWriter methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 23:17'!
writePackage: aPackage
	| file |
	file := self metadataReference / MCIceRepository packageFileName.
	file exists ifTrue: [ file delete ].
	file writeStreamDo: [ :writeStream |
		writeStream nextPutAll: ('MCPackage parseName: ''{1}''' format: { aPackage name }); cr ]! !

!MCIceWriter methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/15/2012 10:36'!
writeVersion: aVersion
	self writePackage: aVersion package.
	self writeVersionInfo: aVersion info.
	self writeDefinitions: aVersion.
	self flag: #todo. "I don't know what to do with this"
	"aVersion dependencies do: [:ea | self writeVersionDependency: ea]	"! !

!MCIceWriter methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 23:17'!
writeVersionInfo: info
	| file |
	file := self metadataReference / MCIceRepository versionFileName.
	file exists ifTrue: [ file delete ].
	file writeStreamDo: [ :writeStream | writeStream nextPutAll: (self toStringVersionInfo: info) ] 
	! !

!MCPackage class methodsFor: '*ice-monticello-extensions' stamp: 'EstebanLorenzano 2/14/2012 20:38'!
parseName: packageName
	^self named: packageName ! !

MCVersionReader subclass: #MCIceReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Monticello'!

!MCIceReader methodsFor: 'private' stamp: 'EstebanLorenzano 2/14/2012 23:12'!
extensionsReference 
	^(self reference / MCIceRepository extensionsFileName) ensureDirectory! !

!MCIceReader methodsFor: 'private' stamp: 'EstebanLorenzano 2/14/2012 22:00'!
extractDefinitionsFrom: aReference 
	| reader |
	reader := aReference readStreamDo: [ :s | MCStReader on: s contents ].
	^reader definitions! !

!MCIceReader methodsFor: 'loading' stamp: 'EstebanLorenzano 2/15/2012 11:13'!
loadDefinitions 
	| files |
	
	files := self reference allEntries 
		select: [ :each | each extension = MCIceRepository extension ].
	definitions := files 
		inject: OrderedCollection new 
		into: [ :allDefinitions :each |  
			allDefinitions 
				addAll: (self extractDefinitionsFrom: each asReference); 
				yourself ]! !

!MCIceReader methodsFor: 'loading' stamp: 'EstebanLorenzano 2/14/2012 22:01'!
loadDependencies 
	self flag: #todo. "No idea how to proceed with this"
	dependencies := #()! !

!MCIceReader methodsFor: 'loading' stamp: 'EstebanLorenzano 2/14/2012 23:12'!
loadPackage
	package := (self metadataReference / MCIceRepository packageFileName) 
		readStreamDo: [ :s | Compiler evaluate: s contents asString ] ! !

!MCIceReader methodsFor: 'loading' stamp: 'EstebanLorenzano 2/14/2012 23:12'!
loadVersionInfo 
	info := (self metadataReference / MCIceRepository versionFileName) 
		readStreamDo: [ :s | Compiler evaluate: s contents asString ] ! !

!MCIceReader methodsFor: 'private' stamp: 'EstebanLorenzano 2/14/2012 23:12'!
metadataReference 
	^(self reference / MCIceRepository metadataFileName) ensureDirectory! !

!MCIceReader methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 20:18'!
reference
	"Stream is a FSReference, here"
	^stream ! !

MCFileRepositoryInspector subclass: #MCIceRepositoryInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Monticello'!

!MCIceRepositoryInspector methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/17/2012 18:11'!
refresh
	| packageNames |
	packageNames := Set new.
	packageList := nil.
	versions := repository readableFileNames collect: [ :each | Array with: each with: '' with: 0 with: each].
	newer := Set new.
	inherited := Set new.
	loaded := Set new.
	
	(MCWorkingCopy allManagers 
"		select: [ :each | packageNames includes: each packageName]")
		do: [:each |
			| latest |
			each ancestors do: [ :ancestor |
				loaded add: ancestor name.
				ancestor ancestorsDoWhileTrue: [:heir |
					(inherited includes: heir name)
						ifTrue: [false]
						ifFalse: [inherited add: heir name. true]]].
			latest := (versions select: [:v | v first = each package name])	
				detectMax: [:v | v third].
			(latest notNil and: [
				each ancestors allSatisfy: [:ancestor |
					| av |
					av := ((ancestor name copyAfterLast: $-) copyAfter: $.) asInteger.
					av < latest third or: [
						av = latest third and: [((ancestor name copyAfterLast: $-) copyUpTo: $.) ~= latest second]]]])
				ifTrue: [newer add: each package name ]].

	self changed: #packageList; changed: #versionList! !

!MCVersionInfo class methodsFor: '*ice-monticello-extensions' stamp: 'EstebanLorenzano 2/14/2012 23:09'!
parseName: versionName id: id message: message date: date time: time author: author
	^ self 
		parseName: versionName
		id: id
		message: message
		date: date
		time: time
		author: author
		ancestors: #()
		stepChildren: #()! !

!MCVersionInfo class methodsFor: '*ice-monticello-extensions' stamp: 'EstebanLorenzano 2/14/2012 20:12'!
parseName: versionName id: id message: message date: date time: time author: author ancestors: ancestors stepChildren: stepChildren
	^ self 
		name: versionName
		id: (UUID fromString: id)
		message: message
		date: (Date readFrom: date readStream)
		time: (Time readFrom: time readStream)
		author: author
		ancestors: ancestors
		stepChildren: stepChildren! !

MCFileBasedRepository subclass: #MCIceRepository
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ice-Monticello'!

!MCIceRepository class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 2/7/2012 19:51'!
description
	^ 'Ice folder'! !

!MCIceRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 21:36'!
extension 
	^'st'! !

!MCIceRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 11:31'!
extensionsFileName 
	^'_Extensions'! !

!MCIceRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 11:31'!
metadataFileName 
	^'_Metadata'! !

!MCIceRepository class methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/7/2012 20:20'!
morphicConfigure
	^(UIManager default chooseDirectoryFrom: (FileDirectory on: FileDirectory default fullName)) 
		ifNotNil: [:directory | 
			self new 
				directory: (FSFilesystem disk resolveString: directory fullName) asReference;
				yourself ]! !

!MCIceRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 20:39'!
packageFileName 
	^'package'! !

!MCIceRepository class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 19:33'!
versionFileName 
	^'version'! !

!MCIceRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/14/2012 19:46'!
allFileNames
	^((self directory entries 
		select: #isDirectory)
		select: [ :entry | self hasMetadata: entry ]) 
		collect: #basename
! !

!MCIceRepository methodsFor: 'converting' stamp: 'EstebanLorenzano 2/7/2012 20:07'!
asRepositorySpecFor: aMetacelloMCProject

	^(aMetacelloMCProject repositorySpec)
		description:  self directory fullName;
	 	type: 'directory';
		yourself! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/15/2012 10:23'!
basicStoreVersion: aVersion
	MCIceWriter fileOut: aVersion on: self directory / aVersion package name ! !

!MCIceRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 2/14/2012 19:46'!
canReadFileNamed: aString
	^self hasMetadata: self directory / aString! !

!MCIceRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 11:49'!
description
	^ 'ice:folder://' , self directory fullName! !

!MCIceRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/7/2012 19:59'!
directory
	^ directory ifNil: [ directory := FSFilesystem disk workingDirectory ]! !

!MCIceRepository methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/7/2012 19:57'!
directory: aReference
	directory := aReference! !

!MCIceRepository methodsFor: 'private' stamp: 'EstebanLorenzano 2/15/2012 10:44'!
hasMetadata: anEntry	
	^anEntry asReference exists 
		and: [ 
			(anEntry asReference entries 
			select: #isDirectory) 
			anySatisfy: [ :each | 
				(each basename = self class metadataFileName)
					and: [ each asReference entries 
						anySatisfy: [ :eachMetadata | eachMetadata basename = self class versionFileName ] ] ] ]! !

!MCIceRepository methodsFor: 'testing' stamp: 'EstebanLorenzano 2/7/2012 20:08'!
isValid
	^self directory exists! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/17/2012 18:11'!
morphicOpen: aWorkingCopy
	(MCIceRepositoryInspector repository: self workingCopy: aWorkingCopy)
		show! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 19:52'!
packageDescriptionFromPackageDirectory: anEntry
	| info packageName |
	
	info := self versionInfoForPackageDirectory: anEntry.
	packageName := info name copyUpToLast: $-.
	^Array 
		with: packageName
		with: info author
		with: info versionNumber
		with: packageName! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 19:51'!
packageDescriptionsFromReadableFileNames
	^self readableFileNames 
		collect: [ :each | self packageDescriptionFromPackageDirectory: each ]! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 20:34'!
readStreamForFileNamed: aString do: aBlock
	^ aBlock value: self directory! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 22:34'!
versionInfoForPackageDirectory: aString
	^ (MCIceReader on: self directory / aString)
		loadVersionInfo;
		info! !

!MCIceRepository methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 2/14/2012 22:34'!
versionReaderForFileNamed: aString do: aBlock
	^ self
		readStreamForFileNamed: aString
		do: [:s | aBlock value: (MCIceReader on: self directory / aString)]
! !
